#property copyright "ZFS"
#property link      "forexzfs.ru vasbsm@mail.ru skype:vasbsm"

#property  indicator_chart_window
#property  indicator_buffers 1
#property  indicator_color1  Magenta
#property  indicator_width1  2

extern int  NBarsM1         = 10000;//-  1, 0 -
extern bool AutoBarInsideTF = false;// BarInsideTF
extern int  BarInsideTF     = 23;//   
extern int  PeriodEMA       = 13;// MACD
extern int  ModeMA          = 1;//0-SMA,1-EMA

int TF=1440;// , 60-

double M[][24];
double T[][24];
int StartMinute,N;


double ema1[];


static int TimeN1=0;

double     Macd[];

int init()
  {
   if (Period()!=60&&Period()!=1440){Alert(" H1  D1.");return(0);}
   if (BarInsideTF>Period()&&Period()!=60){Alert("BarInsideTF     Period()");BarInsideTF=Period();}
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,Macd);
   IndicatorDigits(Digits+2);
   
  }

int deinit()
  {
   ObjectDelete("LMACD");ObjectDelete("LCL");ObjectDelete("LTIME");ObjectDelete("LCL2");//ObjectDelete("LCL3");
  }

int start()
  {
   datetime TimeC1=iTime(NULL,60,0);
   //if (TimeN1==0)TimeN1=TimeC1;
   if(TimeN1!=TimeC1){   
   if (AutoBarInsideTF)BarInsideTF=TimeHour(TimeCurrent());
   if (NBarsM1==0)int sizeM1=iBars(Symbol(),60)-1;else sizeM1=NBarsM1;

   
   datetime start=iTime(NULL,60,sizeM1);
   datetime end  =iTime(NULL,60,1);
   int newSizeM1=(end-start)/3600+1;
   int jM1=sizeM1,i;
      
   int minuta=TimeMinute(iTime(NULL,60,sizeM1));
   int j=0;
   ArrayResize(M,newSizeM1);ArrayInitialize(M,0.0);
   ArrayResize(T,newSizeM1);ArrayInitialize(T,0);
   
   int sizeM60=newSizeM1/24+1;
   ArrayResize(ema1,newSizeM1);ArrayInitialize(ema1,0.0);

   for (i=start;i<=end;i+=3600){
    if (i==iTime(NULL,60,jM1)){
     M[j][minuta]=iClose(NULL,60,iBarShift(NULL,60,i));
     T[j][minuta]=i;

     jM1--;
     
     }
    else {
     if (minuta>0){M[j][minuta]=M[j][minuta-1];T[j][minuta]=T[j][minuta-1];}
      else {M[j][minuta]=M[j-1][23];T[j][minuta]=T[j][minuta-1];}}
    //--
    if(jM1==0)break;
    if (minuta<23)minuta++;else {minuta=0;j++;}
    
   }
   N=j;   


 

   if (Period()==PERIOD_H1){//M1
   
     for (int k=0;k<24;k++){
     for (int l=PeriodEMA+1;l<=N;l++){//   60    

       if (ModeMA==0)ema1[l]=sma(PeriodEMA,l,k);else ema1[l]=ema(PeriodEMA,l,k);


       Macd[iBarShift(NULL,60,T[l][k])]=ema1[l];

      }

     }
     //--      
    }
 else{//MTF

     for (l=PeriodEMA+1;l<=N;l++){//   60    

      if (ModeMA==0)ema1[l]=sma(PeriodEMA,l,BarInsideTF);else ema1[l]=ema(PeriodEMA,l,BarInsideTF);


       Macd[iBarShift(NULL,TF,T[l][BarInsideTF])]=ema1[l];

      }

       
     //--




  
   
   
   } //MTF
  
   //--
   TimeN1=TimeC1;
   }//1
  }
//+------------------------------------------------------------------+
//| Exponential Moving Average                                       |
//+------------------------------------------------------------------+
double ema(int _Period, int _Bars, int mas)
  {
    double pr1=2.0/(_Period+1);
    double _ema=M[_Bars-_Period][mas];

     for (int i=_Bars-_Period+1;i<=_Bars;i++){
      _ema=_ema*(1-pr1)+M[i][mas]*pr1;

     }

    return(_ema); 
  } 
double sma(int _period, int sh,int mas){
   double sum=0;
   for (int i=sh-_period+1;i<=sh;i++)
    sum+=M[i][mas];
   sum=sum/_period;
   return(sum);
  }    